build.sh 18 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701
  1. #!/usr/bin/env bash
  2. # Copyright 2018 Google
  3. #
  4. # Licensed under the Apache License, Version 2.0 (the "License");
  5. # you may not use this file except in compliance with the License.
  6. # You may obtain a copy of the License at
  7. #
  8. # http://www.apache.org/licenses/LICENSE-2.0
  9. #
  10. # Unless required by applicable law or agreed to in writing, software
  11. # distributed under the License is distributed on an "AS IS" BASIS,
  12. # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  13. # See the License for the specific language governing permissions and
  14. # limitations under the License.
  15. # USAGE: build.sh product [platform] [method]
  16. #
  17. # Builds the given product for the given platform using the given build method
  18. function pod_gen() {
  19. # Call pod gen with a podspec and additional optional arguments.
  20. bundle exec pod gen --local-sources=./ --sources=https://github.com/firebase/SpecsDev.git,https://github.com/firebase/SpecsStaging.git,https://cdn.cocoapods.org/ "$@"
  21. }
  22. set -euo pipefail
  23. if [[ $# -lt 1 ]]; then
  24. cat 1>&2 <<EOF
  25. USAGE: $0 product [platform] [method]
  26. product can be one of:
  27. Firebase
  28. Firestore
  29. CombineSwift
  30. InAppMessaging
  31. Messaging
  32. MessagingSample
  33. SwiftUISample
  34. MLModelDownloaderSample
  35. RemoteConfig
  36. RemoteConfigSample
  37. Sessions
  38. Storage
  39. SymbolCollision
  40. GoogleDataTransport
  41. Performance
  42. ClientApp
  43. platform can be one of:
  44. iOS (default)
  45. iOS-device
  46. macOS
  47. tvOS
  48. watchOS
  49. catalyst
  50. visionOS
  51. method can be one of:
  52. xcodebuild (default)
  53. cmake
  54. unit
  55. integration
  56. spm
  57. Optionally, reads the environment variable SANITIZERS. If set, it is expected to
  58. be a string containing a space-separated list with some of the following
  59. elements:
  60. asan
  61. tsan
  62. ubsan
  63. EOF
  64. exit 1
  65. fi
  66. product="$1"
  67. platform="iOS"
  68. if [[ $# -gt 1 ]]; then
  69. platform="$2"
  70. fi
  71. method="xcodebuild"
  72. if [[ $# -gt 2 ]]; then
  73. method="$3"
  74. fi
  75. echo "Building $product for $platform using $method"
  76. if [[ -n "${SANITIZERS:-}" ]]; then
  77. echo "Using sanitizers: $SANITIZERS"
  78. fi
  79. scripts_dir=$(dirname "${BASH_SOURCE[0]}")
  80. firestore_emulator="${scripts_dir}/run_firestore_emulator.sh"
  81. database_emulator="${scripts_dir}/run_database_emulator.sh"
  82. system=$(uname -s)
  83. case "$system" in
  84. Darwin)
  85. xcode_version=$(xcodebuild -version | head -n 1)
  86. xcode_version="${xcode_version/Xcode /}"
  87. xcode_major="${xcode_version/.*/}"
  88. ;;
  89. *)
  90. xcode_major="0"
  91. ;;
  92. esac
  93. # Source function to check if CI secrets are available.
  94. source scripts/check_secrets.sh
  95. # Runs xcodebuild with the given flags, piping output to xcpretty
  96. # If xcodebuild fails with known error codes, retries once.
  97. function RunXcodebuild() {
  98. echo xcodebuild "$@"
  99. xcpretty_cmd=(xcpretty)
  100. result=0
  101. xcodebuild "$@" | tee xcodebuild.log | "${xcpretty_cmd[@]}" || result=$?
  102. if [[ $result == 65 ]]; then
  103. ExportLogs "$@"
  104. echo "xcodebuild exited with 65, retrying" 1>&2
  105. sleep 5
  106. result=0
  107. xcodebuild "$@" | tee xcodebuild.log | "${xcpretty_cmd[@]}" || result=$?
  108. fi
  109. if [[ $result != 0 ]]; then
  110. echo "xcodebuild exited with $result" 1>&2
  111. ExportLogs "$@"
  112. return $result
  113. fi
  114. }
  115. # Exports any logs output captured in the xcresult
  116. function ExportLogs() {
  117. python "${scripts_dir}/xcresult_logs.py" "$@"
  118. }
  119. if [[ "$xcode_major" -lt 15 ]]; then
  120. ios_flags=(
  121. -sdk 'iphonesimulator'
  122. -destination 'platform=iOS Simulator,name=iPhone 14'
  123. )
  124. else
  125. ios_flags=(
  126. -sdk 'iphonesimulator'
  127. -destination 'platform=iOS Simulator,name=iPhone 15'
  128. )
  129. fi
  130. ios_device_flags=(
  131. -sdk 'iphoneos'
  132. -destination 'generic/platform=iOS'
  133. )
  134. ipad_flags=(
  135. -sdk 'iphonesimulator'
  136. -destination 'platform=iOS Simulator,name=iPad Pro (9.7-inch)'
  137. )
  138. macos_flags=(
  139. -sdk 'macosx'
  140. -destination 'platform=OS X,arch=x86_64'
  141. )
  142. tvos_flags=(
  143. -sdk "appletvsimulator"
  144. -destination 'platform=tvOS Simulator,name=Apple TV'
  145. )
  146. watchos_flags=(
  147. -destination 'platform=watchOS Simulator,name=Apple Watch Series 7 (45mm)'
  148. )
  149. visionos_flags=(
  150. -destination 'platform=visionOS Simulator'
  151. )
  152. catalyst_flags=(
  153. ARCHS=x86_64 VALID_ARCHS=x86_64 SUPPORTS_MACCATALYST=YES -sdk macosx
  154. -destination platform="macOS,variant=Mac Catalyst,arch=x86_64" TARGETED_DEVICE_FAMILY=2
  155. CODE_SIGN_IDENTITY=- CODE_SIGNING_REQUIRED=NO CODE_SIGNING_ALLOWED=NO
  156. )
  157. # Compute standard flags for all platforms
  158. case "$platform" in
  159. iOS)
  160. xcb_flags=("${ios_flags[@]}")
  161. gen_platform=ios
  162. ;;
  163. iOS-device)
  164. xcb_flags=("${ios_device_flags[@]}")
  165. gen_platform=ios
  166. ;;
  167. iPad)
  168. xcb_flags=("${ipad_flags[@]}")
  169. ;;
  170. macOS)
  171. xcb_flags=("${macos_flags[@]}")
  172. gen_platform=macos
  173. ;;
  174. tvOS)
  175. xcb_flags=("${tvos_flags[@]}")
  176. gen_platform=tvos
  177. ;;
  178. watchOS)
  179. xcb_flags=("${watchos_flags[@]}")
  180. ;;
  181. visionOS)
  182. xcb_flags=("${visionos_flags[@]}")
  183. ;;
  184. catalyst)
  185. xcb_flags=("${catalyst_flags[@]}")
  186. ;;
  187. all)
  188. xcb_flags=()
  189. ;;
  190. Linux)
  191. xcb_flags=()
  192. ;;
  193. *)
  194. echo "Unknown platform '$platform'" 1>&2
  195. exit 1
  196. ;;
  197. esac
  198. xcb_flags+=(
  199. ONLY_ACTIVE_ARCH=YES
  200. CODE_SIGNING_REQUIRED=NO
  201. CODE_SIGNING_ALLOWED=YES
  202. COMPILER_INDEX_STORE_ENABLE=NO
  203. )
  204. source scripts/buildcache.sh
  205. xcb_flags=("${xcb_flags[@]}" "${buildcache_xcb_flags[@]}")
  206. # TODO(varconst): Add --warn-unused-vars and --warn-uninitialized.
  207. # Right now, it makes the log overflow on Travis because many of our
  208. # dependencies don't build cleanly this way.
  209. cmake_options=(
  210. -Wdeprecated
  211. -DCMAKE_BUILD_TYPE=Debug
  212. )
  213. if [[ -n "${SANITIZERS:-}" ]]; then
  214. for sanitizer in $SANITIZERS; do
  215. case "$sanitizer" in
  216. asan)
  217. xcb_flags+=(
  218. -enableAddressSanitizer YES
  219. )
  220. cmake_options+=(
  221. -DWITH_ASAN=ON
  222. )
  223. ;;
  224. tsan)
  225. xcb_flags+=(
  226. -enableThreadSanitizer YES
  227. )
  228. cmake_options+=(
  229. -DWITH_TSAN=ON
  230. )
  231. ;;
  232. ubsan)
  233. xcb_flags+=(
  234. -enableUndefinedBehaviorSanitizer YES
  235. )
  236. cmake_options+=(
  237. -DWITH_UBSAN=ON
  238. )
  239. ;;
  240. *)
  241. echo "Unknown sanitizer '$sanitizer'" 1>&2
  242. exit 1
  243. ;;
  244. esac
  245. done
  246. fi
  247. case "$product-$platform-$method" in
  248. FirebasePod-iOS-*)
  249. RunXcodebuild \
  250. -workspace 'CoreOnly/Tests/FirebasePodTest/FirebasePodTest.xcworkspace' \
  251. -scheme "FirebasePodTest" \
  252. "${xcb_flags[@]}" \
  253. build
  254. ;;
  255. Auth-*-xcodebuild)
  256. if check_secrets; then
  257. RunXcodebuild \
  258. -workspace 'FirebaseAuth/Tests/Sample/AuthSample.xcworkspace' \
  259. -scheme "Auth_ApiTests" \
  260. "${xcb_flags[@]}" \
  261. test
  262. RunXcodebuild \
  263. -workspace 'FirebaseAuth/Tests/Sample/AuthSample.xcworkspace' \
  264. -scheme "SwiftApiTests" \
  265. "${xcb_flags[@]}" \
  266. test
  267. fi
  268. ;;
  269. CombineSwift-*-xcodebuild)
  270. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  271. RunXcodebuild \
  272. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  273. -scheme "FirebaseCombineSwift-Unit-unit" \
  274. "${xcb_flags[@]}" \
  275. build \
  276. test
  277. ;;
  278. InAppMessaging-*-xcodebuild)
  279. RunXcodebuild \
  280. -workspace 'FirebaseInAppMessaging/Tests/Integration/DefaultUITestApp/InAppMessagingDisplay-Sample.xcworkspace' \
  281. -scheme 'FiamDisplaySwiftExample' \
  282. "${xcb_flags[@]}" \
  283. test
  284. ;;
  285. Firestore-*-xcodebuild)
  286. "${firestore_emulator}" start
  287. trap '"${firestore_emulator}" stop' ERR EXIT
  288. RunXcodebuild \
  289. -workspace 'Firestore/Example/Firestore.xcworkspace' \
  290. -scheme "Firestore_IntegrationTests_$platform" \
  291. -enableCodeCoverage YES \
  292. "${xcb_flags[@]}" \
  293. test
  294. ;;
  295. Firestore-macOS-cmake | Firestore-Linux-cmake)
  296. "${firestore_emulator}" start
  297. trap '"${firestore_emulator}" stop' ERR EXIT
  298. (
  299. test -d build || mkdir build
  300. cd build
  301. echo "Preparing cmake build ..."
  302. cmake -G Ninja "${cmake_options[@]}" ..
  303. echo "Building cmake build ..."
  304. ninja -k 10 all
  305. ctest --verbose
  306. )
  307. ;;
  308. SymbolCollision-*-*)
  309. RunXcodebuild \
  310. -workspace 'SymbolCollisionTest/SymbolCollisionTest.xcworkspace' \
  311. -scheme "SymbolCollisionTest" \
  312. "${xcb_flags[@]}" \
  313. build
  314. ;;
  315. Messaging-*-xcodebuild)
  316. pod_gen FirebaseMessaging.podspec --platforms=ios
  317. # Add GoogleService-Info.plist to generated Test Wrapper App.
  318. ruby ./scripts/update_xcode_target.rb gen/FirebaseMessaging/Pods/Pods.xcodeproj \
  319. AppHost-FirebaseMessaging-Unit-Tests \
  320. ../../../FirebaseMessaging/Tests/IntegrationTests/Resources/GoogleService-Info.plist
  321. if check_secrets; then
  322. # Integration tests are only run on iOS to minimize flake failures.
  323. RunXcodebuild \
  324. -workspace 'gen/FirebaseMessaging/FirebaseMessaging.xcworkspace' \
  325. -scheme "FirebaseMessaging-Unit-integration" \
  326. "${ios_flags[@]}" \
  327. "${xcb_flags[@]}" \
  328. test
  329. fi
  330. ;;
  331. MessagingSample-*-*)
  332. if check_secrets; then
  333. RunXcodebuild \
  334. -workspace 'FirebaseMessaging/Apps/Sample/Sample.xcworkspace' \
  335. -scheme "Sample" \
  336. "${xcb_flags[@]}" \
  337. build
  338. fi
  339. ;;
  340. SwiftUISample-*-*)
  341. if check_secrets; then
  342. RunXcodebuild \
  343. -workspace 'FirebaseMessaging/Apps/SwiftUISample/SwiftUISample.xcworkspace' \
  344. -scheme "SwiftUISample" \
  345. "${xcb_flags[@]}" \
  346. build
  347. fi
  348. ;;
  349. MessagingSampleStandaloneWatchApp-*-*)
  350. if check_secrets; then
  351. RunXcodebuild \
  352. -workspace 'FirebaseMessaging/Apps/SampleStandaloneWatchApp/SampleStandaloneWatchApp.xcworkspace' \
  353. -scheme "SampleStandaloneWatchApp Watch App" \
  354. "${xcb_flags[@]}" \
  355. build
  356. fi
  357. ;;
  358. MLModelDownloaderSample-*-*)
  359. if check_secrets; then
  360. RunXcodebuild \
  361. -workspace 'FirebaseMLModelDownloader/Apps/Sample/MLDownloaderTestApp.xcworkspace' \
  362. -scheme "MLDownloaderTestApp" \
  363. "${xcb_flags[@]}" \
  364. build
  365. fi
  366. ;;
  367. WatchOSSample-*-*)
  368. RunXcodebuild \
  369. -workspace 'Example/watchOSSample/SampleWatchApp.xcworkspace' \
  370. -scheme "SampleWatchAppWatchKitApp" \
  371. "${xcb_flags[@]}" \
  372. build
  373. ;;
  374. Database-*-unit)
  375. pod_gen FirebaseDatabase.podspec --platforms="${gen_platform}"
  376. RunXcodebuild \
  377. -workspace 'gen/FirebaseDatabase/FirebaseDatabase.xcworkspace' \
  378. -scheme "FirebaseDatabase-Unit-unit" \
  379. "${xcb_flags[@]}" \
  380. build \
  381. test
  382. ;;
  383. Database-*-integration)
  384. "${database_emulator}" start
  385. trap '"${database_emulator}" stop' ERR EXIT
  386. pod_gen FirebaseDatabase.podspec --platforms="${gen_platform}"
  387. RunXcodebuild \
  388. -workspace 'gen/FirebaseDatabase/FirebaseDatabase.xcworkspace' \
  389. -scheme "FirebaseDatabase-Unit-integration" \
  390. "${xcb_flags[@]}" \
  391. build \
  392. test
  393. ;;
  394. RemoteConfig-*-fakeconsole)
  395. pod_gen FirebaseRemoteConfigSwift.podspec --platforms="${gen_platform}"
  396. RunXcodebuild \
  397. -workspace 'gen/FirebaseRemoteConfigSwift/FirebaseRemoteConfigSwift.xcworkspace' \
  398. -scheme "FirebaseRemoteConfigSwift-Unit-fake-console-tests" \
  399. "${xcb_flags[@]}" \
  400. build \
  401. test
  402. ;;
  403. RemoteConfig-*-integration)
  404. pod_gen FirebaseRemoteConfigSwift.podspec --platforms="${gen_platform}"
  405. # Add GoogleService-Info.plist to generated Test Wrapper App.
  406. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfigSwift/Pods/Pods.xcodeproj \
  407. AppHost-FirebaseRemoteConfigSwift-Unit-Tests \
  408. ../../../FirebaseRemoteConfigSwift/Tests/SwiftAPI/GoogleService-Info.plist
  409. # Add AccessToken to generated Test Wrapper App.
  410. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfigSwift/Pods/Pods.xcodeproj \
  411. AppHost-FirebaseRemoteConfigSwift-Unit-Tests \
  412. ../../../FirebaseRemoteConfigSwift/Tests/AccessToken.json
  413. RunXcodebuild \
  414. -workspace 'gen/FirebaseRemoteConfigSwift/FirebaseRemoteConfigSwift.xcworkspace' \
  415. -scheme "FirebaseRemoteConfigSwift-Unit-swift-api-tests" \
  416. "${xcb_flags[@]}" \
  417. build \
  418. test
  419. ;;
  420. RemoteConfigSample-*-*)
  421. RunXcodebuild \
  422. -workspace 'FirebaseRemoteConfig/Tests/Sample/RemoteConfigSampleApp.xcworkspace' \
  423. -scheme "RemoteConfigSampleApp" \
  424. "${xcb_flags[@]}" \
  425. build
  426. ;;
  427. Sessions-*-integration)
  428. # Perform "pod install" to install the relevant dependencies
  429. # ./FirebaseSessions/generate_testapp.sh
  430. pod_gen FirebaseSessions.podspec --platforms=ios --clean
  431. cd FirebaseSessions/Tests/TestApp; pod install; cd -
  432. # Run E2E Integration Tests for Prod.
  433. RunXcodebuild \
  434. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  435. -scheme "AppQualityDevApp_iOS" \
  436. "${ios_flags[@]}" \
  437. "${xcb_flags[@]}" \
  438. build \
  439. test
  440. # Run E2E Integration Tests for Staging.
  441. RunXcodebuild \
  442. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  443. -scheme "AppQualityDevApp_iOS" \
  444. FirebaseSessionsRunEnvironment=STAGING \
  445. "${ios_flags[@]}" \
  446. "${xcb_flags[@]}" \
  447. build \
  448. test
  449. # Run E2E Integration Tests for Autopush.
  450. RunXcodebuild \
  451. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  452. -scheme "AppQualityDevApp_iOS" \
  453. FirebaseSessionsRunEnvironment=AUTOPUSH \
  454. "${ios_flags[@]}" \
  455. "${xcb_flags[@]}" \
  456. build \
  457. test
  458. ;;
  459. Storage-*-xcodebuild)
  460. pod_gen FirebaseStorage.podspec --platforms=ios
  461. # Add GoogleService-Info.plist to generated Test Wrapper App.
  462. ruby ./scripts/update_xcode_target.rb gen/FirebaseStorage/Pods/Pods.xcodeproj \
  463. AppHost-FirebaseStorage-Unit-Tests \
  464. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  465. if check_secrets; then
  466. # Integration tests are only run on iOS to minimize flake failures.
  467. RunXcodebuild \
  468. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  469. -scheme "FirebaseStorage-Unit-integration" \
  470. "${ios_flags[@]}" \
  471. "${xcb_flags[@]}" \
  472. test
  473. fi
  474. if check_secrets; then
  475. # Integration tests are only run on iOS to minimize flake failures.
  476. RunXcodebuild \
  477. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  478. -scheme "FirebaseStorage-Unit-ObjCIntegration" \
  479. "${ios_flags[@]}" \
  480. "${xcb_flags[@]}" \
  481. test
  482. fi
  483. ;;
  484. StorageCombine-*-xcodebuild)
  485. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  486. # Add GoogleService-Info.plist to generated Test Wrapper App.
  487. ruby ./scripts/update_xcode_target.rb gen/FirebaseCombineSwift/Pods/Pods.xcodeproj \
  488. AppHost-FirebaseCombineSwift-Unit-Tests \
  489. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  490. if check_secrets; then
  491. # Integration tests are only run on iOS to minimize flake failures.
  492. RunXcodebuild \
  493. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  494. -scheme "FirebaseCombineSwift-Unit-integration" \
  495. "${ios_flags[@]}" \
  496. "${xcb_flags[@]}" \
  497. test
  498. fi
  499. ;;
  500. GoogleDataTransport-watchOS-xcodebuild)
  501. RunXcodebuild \
  502. -workspace 'GoogleDataTransport/GDTWatchOSTestApp/GDTWatchOSTestApp.xcworkspace' \
  503. -scheme "GDTWatchOSTestAppWatchKitApp" \
  504. "${xcb_flags[@]}" \
  505. build
  506. RunXcodebuild \
  507. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  508. -scheme "GDTCCTWatchOSIndependentTestAppWatchKitApp" \
  509. "${xcb_flags[@]}" \
  510. build
  511. RunXcodebuild \
  512. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  513. -scheme "GDTCCTWatchOSCompanionTestApp" \
  514. "${xcb_flags[@]}" \
  515. build
  516. ;;
  517. Performance-*-unit)
  518. # Run unit tests on prod environment with unswizzle capabilities.
  519. export FPR_UNSWIZZLE_AVAILABLE="1"
  520. export FPR_AUTOPUSH_ENV="0"
  521. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  522. RunXcodebuild \
  523. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  524. -scheme "FirebasePerformance-Unit-unit" \
  525. "${xcb_flags[@]}" \
  526. build \
  527. test
  528. ;;
  529. Performance-*-proddev)
  530. # Build the prod dev test app.
  531. export FPR_UNSWIZZLE_AVAILABLE="0"
  532. export FPR_AUTOPUSH_ENV="0"
  533. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  534. RunXcodebuild \
  535. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  536. -scheme "FirebasePerformance-TestApp" \
  537. "${xcb_flags[@]}" \
  538. build
  539. ;;
  540. Performance-*-integration)
  541. # Generate the workspace for the SDK to generate Protobuf files.
  542. export FPR_UNSWIZZLE_AVAILABLE="0"
  543. pod_gen FirebasePerformance.podspec --platforms=ios --clean
  544. # Perform "pod install" to install the relevant dependencies
  545. cd FirebasePerformance/Tests/FIRPerfE2E; pod install; cd -
  546. # Run E2E Integration Tests for Autopush.
  547. RunXcodebuild \
  548. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  549. -scheme "FIRPerfE2EAutopush" \
  550. FPR_AUTOPUSH_ENV=1 \
  551. "${ios_flags[@]}" \
  552. "${xcb_flags[@]}" \
  553. build \
  554. test
  555. # Run E2E Integration Tests for Prod.
  556. RunXcodebuild \
  557. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  558. -scheme "FIRPerfE2EProd" \
  559. "${ios_flags[@]}" \
  560. "${xcb_flags[@]}" \
  561. build \
  562. test
  563. ;;
  564. # Note that the combine tests require setting the minimum iOS and tvOS version to 13.0
  565. *-*-spm)
  566. RunXcodebuild \
  567. -scheme $product \
  568. "${xcb_flags[@]}" \
  569. IPHONEOS_DEPLOYMENT_TARGET=13.0 \
  570. TVOS_DEPLOYMENT_TARGET=13.0 \
  571. test
  572. ;;
  573. *-*-spmbuildonly)
  574. RunXcodebuild \
  575. -scheme $product \
  576. "${xcb_flags[@]}" \
  577. build
  578. ;;
  579. ClientApp-iOS-xcodebuild | ClientApp-iOS13-iOS-xcodebuild)
  580. RunXcodebuild \
  581. -project 'ClientApp/ClientApp.xcodeproj' \
  582. -scheme $product \
  583. "${xcb_flags[@]}" \
  584. build
  585. ;;
  586. ClientApp-CocoaPods*-iOS-xcodebuild)
  587. RunXcodebuild \
  588. -workspace 'ClientApp/ClientApp.xcworkspace' \
  589. -scheme $product \
  590. "${xcb_flags[@]}" \
  591. build
  592. ;;
  593. *)
  594. echo "Don't know how to build this product-platform-method combination" 1>&2
  595. echo " product=$product" 1>&2
  596. echo " platform=$platform" 1>&2
  597. echo " method=$method" 1>&2
  598. exit 1
  599. ;;
  600. esac